Drupal.simple_interactive_maps.ajax_load_map = function (elem, config, region) {

  const backLinks = [];
  // locate the parent map element (with class .interactive_map__wrapper)
  const map = jQuery(elem).closest('.interactive_map__wrapper');

  // Get the immediate parent of map
  const mapParent = map.parent();

  // get the map id
  const map_id = map.attr('id');

  const targetUrl = '/simple-interactive-maps/ajax';

  function buildBackLinks() {
    if (backLinks.length > 0) {

      // Insert a link to load the previous map and insert it above the new map.
      const backLink = document.createElement('a');
      backLink.classList.add('interactive_map__back-link');
      backLink.classList.add('button');
      backLink.href = '#';
      backLink.innerHTML = 'Back to previous map';
      backLink.addEventListener('click', function (e) {
        e.preventDefault();

        const linkConfig = backLinks.pop();

        const backLinkElems = document.querySelectorAll('.interactive_map__back-link');
        backLinkElems.forEach((backLinkElem) => {
          backLinkElem.remove();
        });

        const ajaxSettings = {
          url: targetUrl,
          submit: linkConfig,
        };
        const ajax = new Drupal.ajax(ajaxSettings);
        ajax.execute().then(() => {
          buildBackLinks();
        });
      });

      mapParent.prepend(backLink);
    }
  }

  elem.addEventListener('click', function (e) {
    e.preventDefault();

    const ajaxSettings = {
      url: targetUrl,
      submit: {
        map_to_load: config['target_map_id'],
        target_element: map_id,
      },
    };

    backLinks.push({
      map_to_load: map_id,
      target_element: config['target_map_id'],
    });

    const ajax = new Drupal.ajax(ajaxSettings);
    ajax.execute().then(() => {
      buildBackLinks();
    });

  });

  elem.setAttribute('role', 'link');
};

